<%@ WebHandler Language="C#" Class="GetIcon" %>

using System;
using System.Web;
using System.Web.SessionState;
using System.Web.Services.Protocols;
using TuxWebService;

public class GetIcon : IHttpHandler, IReadOnlySessionState
{
    
    public void ProcessRequest (HttpContext Context) 
    {
        TUXWebServiceClass appListClass = (TUXWebServiceClass)Context.Session["current"];
        
        string icondata = appListClass.GetImage(Context.Request["id"]);
        if (icondata.Length > 0)
        {
            try
            {
                byte[] iconbin = Convert.FromBase64String(icondata);
                // Writing an image to output stream
                Context.Response.ContentType = "image/png";

                // Writing data to output stream
                Context.Response.BinaryWrite(iconbin);
            }
            catch (System.ArgumentNullException)
            {
                System.Console.WriteLine("Base 64 string is null.");
                return;
            }
            catch (System.FormatException)
            {
                System.Console.WriteLine("Base 64 string length is not 4 or is not an even multiple of 4.");
                return;
            }
        }
    }
 
    public bool IsReusable {
        get {
            return false;
        }
    }
}